3 USAGE
='[start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE
='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
7 mark <rev> a known-bad revision.
8 git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
10 git bisect skip [<rev>...]
11 mark <rev>... untestable revisions.
13 find next bisection to test and check it out.
14 git bisect reset [<branch>]
15 finish bisection search and go back to branch.
17 show bisect status in gitk.
18 git bisect replay <logfile>
22 git bisect run <cmd>...
23 use <cmd>... to automatically bisect.'
29 _x40
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
30 _x40
="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35 s/'\''/'\'\\\\\'\''/g;
43 test -f "$GIT_DIR/BISECT_NAMES" ||
{
44 echo >&2 'You need to start by "git bisect start"'
47 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
62 # Verify HEAD. If we were bisecting before this, reset to the
63 # top-of-line master first!
65 head=$
(GIT_DIR
="$GIT_DIR" git symbolic-ref HEAD
) ||
66 head=$
(GIT_DIR
="$GIT_DIR" git rev-parse
--verify HEAD
) ||
67 die
"Bad HEAD - I need a HEAD"
70 if [ -s "$GIT_DIR/BISECT_START" ]; then
71 branch
=`cat "$GIT_DIR/BISECT_START"`
75 git checkout
$branch ||
exit
78 # This error message should only be triggered by cogito usage,
79 # and cogito users should understand it relates to cg-seek.
80 [ -s "$GIT_DIR/head-name" ] && die
"won't bisect on seeked tree"
81 echo "${head#refs/heads/}" >"$GIT_DIR/BISECT_START"
84 die
"Bad HEAD - strange symbolic ref"
89 # Get rid of any old bisect state
94 # Check for one bad and then some good revisions.
98 case "$arg" in --) has_double_dash
=1; break ;; esac
102 while [ $# -gt 0 ]; do
110 rev=$
(git rev-parse
--verify "$arg^{commit}" 2>/dev
/null
) ||
{
111 test $has_double_dash -eq 1 &&
112 die
"'$arg' does not appear to be a valid revision"
116 0) state
='bad' ; bad_seen
=1 ;;
119 bisect_write
"$state" "$rev" 'nolog'
125 sq "$@" >"$GIT_DIR/BISECT_NAMES"
126 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
136 good|skip
) tag
="$state"-"$rev" ;;
137 *) die
"Bad bisect_write argument: $state" ;;
139 git update-ref
"refs/bisect/$tag" "$rev"
140 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
141 test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
149 die
"Please call 'bisect_state' with at least one argument." ;;
151 rev=$
(git rev-parse
--verify HEAD
) ||
152 die
"Bad rev input: HEAD"
153 bisect_write
"$state" "$rev" ;;
158 sha
=$
(git rev-parse
--verify "$rev^{commit}") ||
159 die
"Bad rev input: $rev"
160 bisect_write
"$state" "$sha"
163 die
"'git bisect bad' can take only one argument." ;;
170 bisect_next_check
() {
171 missing_good
= missing_bad
=
172 git show-ref
-q --verify refs
/bisect
/bad || missing_bad
=t
173 test -n "$(git for-each-ref "refs
/bisect
/good-
*")" || missing_good
=t
175 case "$missing_good,$missing_bad,$1" in
177 : have both good and bad
- ok
180 # do not have both but not asked to fail - just report.
184 # have bad but not good. we could bisect although
185 # this is less optimum.
186 echo >&2 'Warning: bisecting only with a bad commit.'
189 printf >&2 'Are you sure [Y/n]? '
190 case "$(read yesno)" in [Nn
]*) exit 1 ;; esac
192 : bisect without good...
196 test -f "$GIT_DIR/BISECT_NAMES" ||
{
197 echo >&2 'You need to start by "git bisect start".'
200 echo >&2 'You '$THEN'need to give me at least one good' \
201 'and one bad revisions.'
202 echo >&2 '(You can use "git bisect bad" and' \
203 '"git bisect good" for that.)'
209 bisect_next_check
&& bisect_next ||
:
216 if [ -z "$_skip" ]; then
221 # Let's parse the output of:
222 # "git rev-list --bisect-vars --bisect-all ..."
223 eval $_eval |
while read hash line
225 case "$VARS,$FOUND,$TRIED,$hash" in
226 # We display some vars.
227 1,*,*,*) echo "$hash $line" ;;
232 # We had nothing to search.
238 # We did not find a good bisect rev.
239 # This should happen only if the "bad"
240 # commit is also a "skip" commit.
242 echo "bisect_rev=$TRIED"
248 TRIED
="${TRIED:+$TRIED|}$hash"
252 echo "bisect_rev=$hash"
253 echo "bisect_tried=\"$TRIED\""
259 # We have already found a rev to be tested.
260 ,1,*,bisect_rev
*) VARS
=1 ;;
264 *) die
"filter_skipped error " \
275 exit_if_skipped_commits
() {
277 if expr "$_tried" : ".*[|].*" > /dev
/null
; then
278 echo "There are only 'skip'ped commit left to test."
279 echo "The first bad commit could be any of:"
280 echo "$_tried" |
tr '[|]' '[\012]'
281 echo "We cannot bisect more!"
287 case "$#" in 0) ;; *) usage
;; esac
289 bisect_next_check good
291 skip
=$
(git for-each-ref
--format='%(objectname)' \
292 "refs/bisect/skip-*" |
tr '\012' ' ') ||
exit
295 test -n "$skip" && BISECT_OPT
='--bisect-all'
297 bad
=$
(git rev-parse
--verify refs
/bisect
/bad
) &&
298 good
=$
(git for-each-ref
--format='^%(objectname)' \
299 "refs/bisect/good-*" |
tr '\012' ' ') &&
300 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
301 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES
")" &&
302 eval=$
(filter_skipped
"$eval" "$skip") &&
305 if [ -z "$bisect_rev" ]; then
306 echo "$bad was both good and bad"
309 if [ "$bisect_rev" = "$bad" ]; then
310 exit_if_skipped_commits
"$bisect_tried"
311 echo "$bisect_rev is first bad commit"
312 git diff-tree
--pretty $bisect_rev
316 # We should exit here only if the "bad"
317 # commit is also a "skip" commit (see above).
318 exit_if_skipped_commits
"$bisect_rev"
320 echo "Bisecting: $bisect_nr revisions left to test after this"
321 git branch
-f new-bisect
"$bisect_rev"
322 git checkout
-q new-bisect ||
exit
323 git branch
-M new-bisect bisect
324 git show-branch
"$bisect_rev"
328 bisect_next_check fail
332 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
339 -*) set git log
"$@" ;;
344 not
=$
(git for-each-ref
--format='%(refname)' "refs/bisect/good-*")
345 eval '"$@"' refs
/bisect
/bad
--not $not -- $
(cat "$GIT_DIR/BISECT_NAMES")
349 test -f "$GIT_DIR/BISECT_NAMES" ||
{
350 echo "We are not bisecting."
354 0) if [ -s "$GIT_DIR/BISECT_START" ]; then
355 branch
=`cat "$GIT_DIR/BISECT_START"`
359 1) git show-ref
--verify --quiet -- "refs/heads/$1" ||
360 die
"$1 does not seem to be a valid branch"
365 if git checkout
"$branch"; then
366 # Cleanup head-name if it got left by an old version of git-bisect
367 rm -f "$GIT_DIR/head-name"
368 rm -f "$GIT_DIR/BISECT_START"
373 bisect_clean_state
() {
374 # There may be some refs packed during bisection.
375 git for-each-ref
--format='%(refname) %(objectname)' refs
/bisect
/\
* refs
/heads
/bisect |
378 git update-ref
-d $ref $hash
380 rm -f "$GIT_DIR/BISECT_LOG"
381 rm -f "$GIT_DIR/BISECT_NAMES"
382 rm -f "$GIT_DIR/BISECT_RUN"
386 test -r "$1" || die
"cannot read $1 for replaying"
388 while read bisect
command rev
390 test "$bisect" = "git-bisect" ||
continue
393 cmd
="bisect_start $rev"
396 bisect_write
"$command" "$rev" ;;
398 die
"?? what are you talking about?" ;;
405 bisect_next_check fail
413 # Check for really bad run error.
414 if [ $res -lt 0 -o $res -ge 128 ]; then
415 echo >&2 "bisect run failed:"
416 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
420 # Find current state depending on run success or failure.
421 # A special exit code of 125 means cannot test.
422 if [ $res -eq 125 ]; then
424 elif [ $res -gt 0 ]; then
430 # We have to use a subshell because "bisect_state" can exit.
431 ( bisect_state
$state > "$GIT_DIR/BISECT_RUN" )
434 cat "$GIT_DIR/BISECT_RUN"
436 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
438 echo >&2 "bisect run cannot continue any more"
442 if [ $res -ne 0 ]; then
443 echo >&2 "bisect run failed:"
444 echo >&2 "'bisect_state $state' exited with error code $res"
448 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev
/null
; then
449 echo "bisect run success"
467 bisect_state
"$cmd" "$@" ;;
469 # Not sure we want "next" at the UI level anymore.
472 bisect_visualize
"$@" ;;
476 bisect_replay
"$@" ;;
478 cat "$GIT_DIR/BISECT_LOG" ;;